
#ifndef _MV_OBSOLETE_CAM_PARAMS_H_
#define _MV_OBSOLETE_CAM_PARAMS_H_

#include "PixelType.h"

/// \~chinese ֡Ϣ             \~english Output Frame Information
typedef struct _MV_FRAME_OUT_INFO_
{
    unsigned short      nWidth;             ///< [OUT]  \~chinese ͼ            \~english Image Width
    unsigned short      nHeight;            ///< [OUT]  \~chinese ͼ            \~english Image Height
    enum MvGvspPixelType    enPixelType;    ///< [OUT]  \~chinese ظʽ          \~english Pixel Type

    unsigned int        nFrameNum;          ///< [OUT]  \~chinese ֡              \~english Frame Number
    unsigned int        nDevTimeStampHigh;  ///< [OUT]  \~chinese ʱ32λ      \~english Timestamp high 32 bits
    unsigned int        nDevTimeStampLow;   ///< [OUT]  \~chinese ʱ32λ      \~english Timestamp low 32 bits
    unsigned int        nReserved0;         ///< [OUT]  \~chinese 8ֽڶ   \~english Reserved, 8-byte aligned
    int64_t             nHostTimeStamp;     ///< [OUT]  \~chinese ɵʱ  \~english Host-generated timestamp

    unsigned int        nFrameLen;

    unsigned int        nLostPacket;  // ֡
    unsigned int        nReserved[2];
}MV_FRAME_OUT_INFO;

/// \~chinese ͼƬ            \~english Save image type
typedef struct _MV_SAVE_IMAGE_PARAM_T_
{
    unsigned char*      pData;              ///< [IN]   \~chinese ݻ      \~english Input Data Buffer
    unsigned int        nDataLen;           ///< [IN]   \~chinese ݴС      \~english Input Data Size
    enum MvGvspPixelType    enPixelType;    ///< [IN]   \~chinese ظʽ      \~english Input Data Pixel Format
    unsigned short      nWidth;             ///< [IN]   \~chinese ͼ            \~english Image Width
    unsigned short      nHeight;            ///< [IN]   \~chinese ͼ            \~english Image Height

    unsigned char*      pImageBuffer;       ///< [OUT]  \~chinese ͼƬ      \~english Output Image Buffer
    unsigned int        nImageLen;          ///< [OUT]  \~chinese ͼƬС      \~english Output Image Size
    unsigned int        nBufferSize;        ///< [IN]   \~chinese ṩС  \~english Output buffer size provided
    enum MV_SAVE_IAMGE_TYPE enImageType;    ///< [IN]   \~chinese ͼƬʽ      \~english Output Image Format

}MV_SAVE_IMAGE_PARAM;

typedef struct _MV_IMAGE_BASIC_INFO_
{
    unsigned short      nWidthValue;
    unsigned short      nWidthMin;
    unsigned int        nWidthMax;
    unsigned int        nWidthInc;

    unsigned int        nHeightValue;
    unsigned int        nHeightMin;
    unsigned int        nHeightMax;
    unsigned int        nHeightInc;

    float               fFrameRateValue;
    float               fFrameRateMin;
    float               fFrameRateMax;

    unsigned int        enPixelType;        ///< [OUT]  \~chinese ǰظʽ    \~english Current pixel format
    unsigned int        nSupportedPixelFmtNum;  ///< [OUT]  \~chinese ֵ֧ظʽ    \~english Support pixel format
    unsigned int        enPixelList[MV_MAX_XML_SYMBOLIC_NUM];
    unsigned int        nReserved[8];

}MV_IMAGE_BASIC_INFO;


/// \~chinese     \~english Noise feature type
typedef enum _MV_CC_BAYER_NOISE_FEATURE_TYPE
{
    MV_CC_BAYER_NOISE_FEATURE_TYPE_INVALID = 0, ///<        \~chinese Чֵ                        \~english Invalid
    MV_CC_BAYER_NOISE_FEATURE_TYPE_PROFILE = 1, ///<        \~chinese                       \~english Noise curve
    MV_CC_BAYER_NOISE_FEATURE_TYPE_LEVEL   = 2, ///<        \~chinese ˮƽ                      \~english Noise level
    MV_CC_BAYER_NOISE_FEATURE_TYPE_DEFAULT = 1, ///<        \~chinese Ĭֵ                        \~english Default

}MV_CC_BAYER_NOISE_FEATURE_TYPE;

/// \~chinese BayerʽϢ    \~english Denoise profile info
typedef struct _MV_CC_BAYER_NOISE_PROFILE_INFO_T_
{
    unsigned int        nVersion;           ///<  \~chinese 汾                           \~english version
    MV_CC_BAYER_NOISE_FEATURE_TYPE enNoiseFeatureType;  ///<  \~chinese        \~english noise feature type
    enum MvGvspPixelType    enPixelType;    ///<  \~chinese ͼʽ                       \~english image format
    int                 nNoiseLevel;        ///<  \~chinese ƽˮƽ                   \~english noise level
    unsigned int        nCurvePointNum;     ///<  \~chinese ߵ                       \~english curve point number
    int*                nNoiseCurve;        ///<  \~chinese                        \~english noise curve
    int*                nLumCurve;          ///<  \~chinese                        \~english luminance curve

    unsigned int        nRes[8];            ///<       \~chinese Ԥ                           \~english Reserved

}MV_CC_BAYER_NOISE_PROFILE_INFO;

/// \~chinese BayerʽƲ    \~english Bayer noise estimate param
typedef struct _MV_CC_BAYER_NOISE_ESTIMATE_PARAM_T_
{
    unsigned int        nWidth;             ///< [IN]  \~chinese ͼ(ڵ8)              \~english Width
    unsigned int        nHeight;            ///< [IN]  \~chinese ͼ(ڵ8)              \~english Height
    enum MvGvspPixelType    enPixelType;    ///< [IN]  \~chinese ظʽ                       \~english Pixel format

    unsigned char*      pSrcData;           ///< [IN]  \~chinese ݻ                   \~english Input data buffer
    unsigned int        nSrcDataLen;        ///< [IN]  \~chinese ݴС                   \~english Input data size

    unsigned int        nNoiseThreshold;    ///< [IN]  \~chinese ֵ(0-4095)               \~english Noise Threshold

    unsigned char*      pCurveBuf;          ///< [IN]  \~chinese ڴ洢ߺߣҪⲿ䣬С4096 * sizeof(int) * 2     \~english Buffer used to store noise and brightness curves, size:4096 * sizeof(int) * 2)
    MV_CC_BAYER_NOISE_PROFILE_INFO stNoiseProfile; ///< [OUT]  \~chinese Ϣ               \~english Denoise profile

    unsigned int        nThreadNum;         ///< [IN]  \~chinese ߳0ʾ㷨ӲӦ1ʾ̣߳Ĭϣ1ʾ߳Ŀ      \~english Thread number, 0 means that the library is adaptive to the hardware, 1 means single thread(Default value), Greater than 1 indicates the number of threads

    unsigned int        nRes[8];            ///<       \~chinese Ԥ                           \~english Reserved

}MV_CC_BAYER_NOISE_ESTIMATE_PARAM;

/// \~chinese Bayerʽ    \~english Bayer spatial Denoise param
typedef struct _MV_CC_BAYER_SPATIAL_DENOISE_PARAM_T_
{
    unsigned int        nWidth;             ///< [IN]  \~chinese ͼ(ڵ8)              \~english Width
    unsigned int        nHeight;            ///< [IN]  \~chinese ͼ(ڵ8)              \~english Height
    enum MvGvspPixelType    enPixelType;        ///< [IN]  \~chinese ظʽ                       \~english Pixel format

    unsigned char*      pSrcData;           ///< [IN]  \~chinese ݻ                   \~english Input data buffer
    unsigned int        nSrcDataLen;        ///< [IN]  \~chinese ݴС                   \~english Input data size

    unsigned char*      pDstBuf;            ///< [OUT] \~chinese                \~english Output data buffer
    unsigned int        nDstBufSize;        ///< [IN]  \~chinese ṩС           \~english Provided output buffer size
    unsigned int        nDstBufLen;         ///< [OUT] \~chinese ݳ           \~english Output data length

    MV_CC_BAYER_NOISE_PROFILE_INFO stNoiseProfile; ///< [IN]  \~chinese Ϣ(Դ)   \~english Denoise profile
    unsigned int        nDenoiseStrength;   ///< [IN]  \~chinese ǿ(0-100)                \~english nDenoise Strength   
    unsigned int        nSharpenStrength;   ///< [IN]  \~chinese ǿ(0-32)                 \~english Sharpen Strength
    unsigned int        nNoiseCorrect;      ///< [IN]  \~chinese Уϵ(0-1280)           \~english Noise Correct  

    unsigned int        nThreadNum;         ///< [IN]  \~chinese ߳0ʾ㷨ӲӦ1ʾ̣߳Ĭϣ1ʾ߳Ŀ         \~english Thread number, 0 means that the library is adaptive to the hardware, 1 means single thread(Default value), Greater than 1 indicates the number of threads

    unsigned int        nRes[8];            ///<       \~chinese Ԥ                           \~english Reserved

}MV_CC_BAYER_SPATIAL_DENOISE_PARAM;

/// \~chinese CLUT                  \~english CLUT param
typedef struct _MV_CC_CLUT_PARAM_T_
{
    bool                bCLUTEnable;                                ///< [IN]  \~chinese ǷCLUT           \~english CLUT enable
    unsigned int        nCLUTScale;                                 ///< [IN]  \~chinese ϵ(2,65536)  \~english Quantitative scale(Integer power of 2, <= 65536)
    unsigned int        nCLUTSize;                                  ///< [IN]  \~chinese CLUTС,[17,33]ֵ17     \~english CLUT size[17,33](Recommended values of 17)
    unsigned char*      pCLUTBuf;                                   ///< [IN]  \~chinese CLUT             \~english CLUT buffer
    unsigned int        nCLUTBufLen;                                ///< [IN]  \~chinese CLUTС(nCLUTSize*nCLUTSize*nCLUTSize*sizeof(int)*3)  \~english CLUT buffer length(nCLUTSize*nCLUTSize*nCLUTSize*sizeof(int)*3)

    unsigned int        nRes[8];                                    ///<       \~chinese Ԥ                   \~english Reserved

}MV_CC_CLUT_PARAM;

/// \~chinese 񻯽ṹ                \~english Sharpen structure
typedef struct _MV_CC_SHARPEN_PARAM_T_
{
    unsigned int            nWidth;                                 ///< [IN]  \~chinese ͼ(С8)        \~english Image Width
    unsigned int            nHeight;                                ///< [IN]  \~chinese ͼ߶(С8)        \~english Image Height
    unsigned char*          pSrcBuf;                                ///< [IN]  \~chinese ݻ           \~english Input data buffer
    unsigned int            nSrcBufLen;                             ///< [IN]  \~chinese ݴС           \~english Input data length
    enum MvGvspPixelType    enPixelType;                            ///< [IN]  \~chinese ظʽ               \~english Pixel format

    unsigned char*          pDstBuf;                                ///< [OUT] \~chinese ݻ           \~english Output data buffer
    unsigned int            nDstBufSize;                            ///< [IN]  \~chinese ṩС   \~english Provided output buffer size
    unsigned int            nDstBufLen;                             ///< [OUT] \~chinese ݳ           \~english Output data length

    unsigned int            nSharpenAmount;                         ///< [IN]  \~chinese ȵǿȣ[0,500]  \~english Sharpen amount,[0,500]  //   [nSharpenAmount ϣ ʹ nSharpenPosAmount & nSharpenNegAmount  ]
    unsigned int            nSharpenRadius;                         ///< [IN]  \~chinese ȵڰ뾶(뾶Խ󣬺ʱԽ)[1,21]   \~english Sharpen radius(The larger the radius, the longer it takes),[1,21]
    unsigned int            nSharpenThreshold;                      ///< [IN]  \~chinese ȵֵ[0,255]  \~english Sharpen threshold,[0,255]


    unsigned int        nSharpenPosAmount;     // [IN]     ȵǿȣΧ:[0, 500]  
    unsigned int        nSharpenNegAmount;     // [IN]     ȵڸǿȣΧ:[0, 500]    

    unsigned int            nRes[6];                                ///<       \~chinese Ԥ                   \~english Reserved

}MV_CC_SHARPEN_PARAM;

/// \~chinese ɫУṹ            \~english Color correct structure
typedef struct _MV_CC_COLOR_CORRECT_PARAM_T_
{
    unsigned int            nWidth;                                 ///< [IN]  \~chinese ͼ               \~english Image Width
    unsigned int            nHeight;                                ///< [IN]  \~chinese ͼ߶               \~english Image Height
    unsigned char*          pSrcBuf;                                ///< [IN]  \~chinese ݻ           \~english Input data buffer
    unsigned int            nSrcBufLen;                             ///< [IN]  \~chinese ݴС           \~english Input data length
    enum MvGvspPixelType    enPixelType;                            ///< [IN]  \~chinese ظʽ               \~english Pixel format

    unsigned char*          pDstBuf;                                ///< [OUT] \~chinese ݻ           \~english Output data buffer
    unsigned int            nDstBufSize;                            ///< [IN]  \~chinese ṩС   \~english Provided output buffer size
    unsigned int            nDstBufLen;                             ///< [OUT] \~chinese ݳ           \~english Output data length

    unsigned int            nImageBit;                              ///< [IN]  \~chinese Чͼλ(8,10,12,16)   \~english Image bit(8 or 10 or 12 or 16)
    MV_CC_GAMMA_PARAM       stGammaParam;                           ///< [IN]  \~chinese GammaϢ              \~english Gamma info
    MV_CC_CCM_PARAM_EX      stCCMParam;                             ///< [IN]  \~chinese CCMϢ                \~english CCM info
    MV_CC_CLUT_PARAM        stCLUTParam;                            ///< [IN]  \~chinese CLUTϢ               \~english CLUT info

    unsigned int            nRes[8];                                ///<       \~chinese Ԥ                   \~english Reserved

}MV_CC_COLOR_CORRECT_PARAM;

/// \~chinese ROIṹ             \~english Rect ROI structure
typedef struct _MV_CC_RECT_I_
{
    unsigned int nX;                                                ///< \~chinese ϽX            \~english X Position
    unsigned int nY;                                                ///< \~chinese ϽY            \~english Y Position
    unsigned int nWidth;                                            ///< \~chinese ο                     \~english Rect Width
    unsigned int nHeight;                                           ///< \~chinese θ߶                     \~english Rect Height

}MV_CC_RECT_I;

/// \~chinese ƽṹ            \~english Noise estimate structure
typedef struct _MV_CC_NOISE_ESTIMATE_PARAM_T_
{
    unsigned int            nWidth;                                 ///< [IN]  \~chinese ͼ(С8)        \~english Image Width
    unsigned int            nHeight;                                ///< [IN]  \~chinese ͼ߶(С8)        \~english Image Height
    enum MvGvspPixelType    enPixelType;                            ///< [IN]  \~chinese ظʽ               \~english Pixel format
    unsigned char*          pSrcBuf;                                ///< [IN]  \~chinese ݻ           \~english Input data buffer
    unsigned int            nSrcBufLen;                             ///< [IN]  \~chinese ݴС           \~english Input data length

    MV_CC_RECT_I*           pstROIRect;                             ///< [IN]  \~chinese ͼROI                \~english Image ROI
    unsigned int            nROINum;                                ///< [IN]  \~chinese ROI                \~english ROI number

    ///< \~chinese BayerƲMono8/RGBЧ     \~english Bayer Noise estimate param,Mono8/RGB formats are invalid
    unsigned int            nNoiseThreshold;                        ///< [IN]  \~chinese ֵ[0,4095]       \~english Noise threshold[0,4095]
    ///< \~chinese ֵ:8bit,0xE0;10bit,0x380;12bit,0xE00     \~english Suggestive value:8bit,0xE0;10bit,0x380;12bit,0xE00

    unsigned char*          pNoiseProfile;                          ///< [OUT] \~chinese            \~english Output Noise Profile
    unsigned int            nNoiseProfileSize;                      ///< [IN]  \~chinese ṩС   \~english Provided output buffer size
    unsigned int            nNoiseProfileLen;                       ///< [OUT] \~chinese Գ       \~english Output Noise Profile length

    unsigned int            nRes[8];                                ///<       \~chinese Ԥ                   \~english Reserved

}MV_CC_NOISE_ESTIMATE_PARAM;

/// \~chinese ṹ            \~english Spatial denoise structure
typedef struct _MV_CC_SPATIAL_DENOISE_PARAM_T_
{
    unsigned int            nWidth;                                 ///< [IN]  \~chinese ͼ(С8)        \~english Image Width
    unsigned int            nHeight;                                ///< [IN]  \~chinese ͼ߶(С8)        \~english Image Height
    enum MvGvspPixelType    enPixelType;                            ///< [IN]  \~chinese ظʽ               \~english Pixel format
    unsigned char*          pSrcBuf;                                ///< [IN]  \~chinese ݻ           \~english Input data buffer
    unsigned int            nSrcBufLen;                             ///< [IN]  \~chinese ݴС           \~english Input data length

    unsigned char*          pDstBuf;                                ///< [OUT] \~chinese        \~english Output data buffer
    unsigned int            nDstBufSize;                            ///< [IN]  \~chinese ṩС   \~english Provided output buffer size
    unsigned int            nDstBufLen;                             ///< [OUT] \~chinese ݳ   \~english Output data length

    unsigned char*          pNoiseProfile;                          ///< [IN]  \~chinese            \~english Input Noise Profile
    unsigned int            nNoiseProfileLen;                       ///< [IN]  \~chinese Գ       \~english Input Noise Profile length

    ///< \~chinese BayerMono8/RGBЧ     \~english Bayer Spatial denoise param,Mono8/RGB formats are invalid
    unsigned int            nBayerDenoiseStrength;                  ///< [IN]  \~chinese ǿ[0,100]        \~english Denoise Strength[0,100]
    unsigned int            nBayerSharpenStrength;                  ///< [IN]  \~chinese ǿ[0,32]         \~english Sharpen Strength[0,32]
    unsigned int            nBayerNoiseCorrect;                     ///< [IN]  \~chinese Уϵ[0,1280]   \~english Noise Correct[0,1280]

    ///< \~chinese Mono8/RGBBayerЧ     \~english Mono8/RGB Spatial denoise param,Bayer formats are invalid
    unsigned int            nNoiseCorrectLum;                       ///< [IN]  \~chinese Уϵ[1,2000]   \~english Noise Correct Lum[1,2000]
    unsigned int            nNoiseCorrectChrom;                     ///< [IN]  \~chinese ɫУϵ[1,2000]   \~english Noise Correct Chrom[1,2000]
    unsigned int            nStrengthLum;                           ///< [IN]  \~chinese Ƚǿ[0,100]    \~english Strength Lum[0,100]
    unsigned int            nStrengthChrom;                         ///< [IN]  \~chinese ɫǿ[0,100]    \~english Strength Chrom[0,100]
    unsigned int            nStrengthSharpen;                       ///< [IN]  \~chinese ǿ[1,1000]       \~english Strength Sharpen[1,1000]

    unsigned int            nRes[8];                                ///<       \~chinese Ԥ                   \~english Reserved

}MV_CC_SPATIAL_DENOISE_PARAM;

/// \~chinese LSC궨ṹ             \~english LSC calib structure
typedef struct _MV_CC_LSC_CALIB_PARAM_T_
{
    unsigned int            nWidth;                                 ///< [IN]  \~chinese ͼ[16,65535]     \~english Image Width
    unsigned int            nHeight;                                ///< [IN]  \~chinese ͼ߶[16-65535]     \~english Image Height
    enum MvGvspPixelType    enPixelType;                            ///< [IN]  \~chinese ظʽ               \~english Pixel format
    unsigned char*          pSrcBuf;                                ///< [IN]  \~chinese ݻ           \~english Input data buffer
    unsigned int            nSrcBufLen;                             ///< [IN]  \~chinese ݳ           \~english Input data length

    unsigned char*          pCalibBuf;                              ///< [OUT] \~chinese 궨         \~english Output calib buffer
    unsigned int            nCalibBufSize;                          ///< [IN]  \~chinese ṩı궨С(nWidth*nHeight*sizeof(unsigned short))    \~english Provided output buffer size
    unsigned int            nCalibBufLen;                           ///< [OUT] \~chinese 궨泤     \~english Output calib buffer length

    unsigned int            nSecNumW;                               ///< [IN]  \~chinese ȷֿ             \~english Width Sec num
    unsigned int            nSecNumH;                               ///< [IN]  \~chinese ߶ȷֿ             \~english Height Sec num
    unsigned int            nPadCoef;                               ///< [IN]  \~chinese Եϵ[1,5]      \~english Pad Coef[1,5]
    unsigned int            nCalibMethod;                           ///< [IN]  \~chinese 궨ʽ(0-Ϊ׼;1-Ϊ׼;2-ĿΪ׼) \~english Calib method
    unsigned int            nTargetGray;                            ///< [IN]  \~chinese Ŀ(궨ʽΪ2ʱЧ)    \~english Target Gray
    ///< \~chinese 8λ,Χ[0,255]            \~english 8bit,range:[0,255]
    ///< \~chinese 10λ,Χ[0,1023]          \~english 10bit,range:[0,1023]
    ///< \~chinese 12λ,Χ[0,4095]          \~english 12bit,range:[0,4095]

    unsigned int            nRes[8];                                ///<       \~chinese Ԥ                   \~english Reserved

}MV_CC_LSC_CALIB_PARAM;

/// \~chinese LSCУṹ             \~english LSC correct structure
typedef struct _MV_CC_LSC_CORRECT_PARAM_T_
{
    unsigned int            nWidth;                                 ///< [IN]  \~chinese ͼ[16,65535]     \~english Image Width
    unsigned int            nHeight;                                ///< [IN]  \~chinese ͼ߶[16,65535]     \~english Image Height
    enum MvGvspPixelType    enPixelType;                            ///< [IN]  \~chinese ظʽ               \~english Pixel format
    unsigned char*          pSrcBuf;                                ///< [IN]  \~chinese ݻ           \~english Input data buffer
    unsigned int            nSrcBufLen;                             ///< [IN]  \~chinese ݳ           \~english Input data length

    unsigned char*          pDstBuf;                                ///< [OUT] \~chinese ݻ           \~english Output data buffer
    unsigned int            nDstBufSize;                            ///< [IN]  \~chinese ṩС   \~english Provided output buffer size
    unsigned int            nDstBufLen;                             ///< [OUT] \~chinese ݳ           \~english Output data length

    unsigned char*          pCalibBuf;                              ///< [IN]  \~chinese 궨         \~english Input calib buffer
    unsigned int            nCalibBufLen;                           ///< [IN]  \~chinese 궨泤     \~english Input calib buffer length

    unsigned int            nRes[8];                                ///<       \~chinese Ԥ                   \~english Reserved

}MV_CC_LSC_CORRECT_PARAM;

/// \~chinese ĳڵӦӽڵֵ    \~english The maximum number of child nodes corresponding to a node
#define MV_MAX_XML_NODE_NUM_C       128

/// \~chinese ڵַ󳤶            \~english The maximum length of node name string
#define MV_MAX_XML_NODE_STRLEN_C    64

/// \~chinese ڵStringֵ󳤶              \~english The maximum length of Node String
#define MV_MAX_XML_STRVALUE_STRLEN_C 64

/// \~chinese ڵֶ󳤶              \~english The maximum length of the node description field
#define MV_MAX_XML_DISC_STRLEN_C    512

/// \~chinese ĵԪ                      \~english The maximum number of units
#define MV_MAX_XML_ENTRY_NUM        10

/// \~chinese ڵ                    \~english The maximum number of parent nodes
#define MV_MAX_XML_PARENTS_NUM      8

/// \~chinese ÿѾʵֵԪƳ        \~english The length of the name of each unit that has been implemented
#define MV_MAX_XML_SYMBOLIC_STRLEN_C 64

enum MV_XML_Visibility
{
    V_Beginner      = 0,    ///< Always visible
    V_Expert        = 1,    ///< Visible for experts or Gurus
    V_Guru          = 2,    ///< Visible for Gurus
    V_Invisible     = 3,    ///< Not Visible
    V_Undefined     = 99    ///< Object is not yet initialized
};

/// \~chinese ڵ | en:Single Node Basic Attributes
typedef struct _MV_XML_NODE_FEATURE_
{
    enum MV_XML_InterfaceType   enType;                             ///< \~chinese ڵ         \~english Node Type
    enum MV_XML_Visibility  enVisivility;                           ///< \~chinese Ƿɼ         \~english Is visibility
    char                strDescription[MV_MAX_XML_DISC_STRLEN_C];   ///< \~chinese ڵ,Ŀǰݲ֧   \~english Node Description, NOT SUPPORT NOW
    char                strDisplayName[MV_MAX_XML_NODE_STRLEN_C];   ///< \~chinese ʾ         \~english Display Name
    char                strName[MV_MAX_XML_NODE_STRLEN_C];          ///< \~chinese ڵ           \~english Node Name
    char                strToolTip[MV_MAX_XML_DISC_STRLEN_C];       ///< \~chinese ʾ             \~english Notice

    unsigned int        nReserved[4];
}MV_XML_NODE_FEATURE;

/// \~chinese ڵб | en:Node List
typedef struct _MV_XML_NODES_LIST_
{
    unsigned int        nNodeNum;       ///< \~chinese ڵ             \~english Node Number
    MV_XML_NODE_FEATURE stNodes[MV_MAX_XML_NODE_NUM_C];
}MV_XML_NODES_LIST;

typedef struct _MV_XML_FEATURE_Value_
{
    enum MV_XML_InterfaceType   enType;                             ///< \~chinese ڵ         \~english Node Type
    char                strDescription[MV_MAX_XML_DISC_STRLEN_C];   ///< \~chinese ڵ,Ŀǰݲ֧   \~english Node Description, NOT SUPPORT NOW
    char                strDisplayName[MV_MAX_XML_NODE_STRLEN_C];   ///< \~chinese ʾ         \~english Display Name
    char                strName[MV_MAX_XML_NODE_STRLEN_C];          ///< \~chinese ڵ           \~english Node Name
    char                strToolTip[MV_MAX_XML_DISC_STRLEN_C];       ///< \~chinese ʾ             \~english Notice
    unsigned int        nReserved[4];
}MV_XML_FEATURE_Value;

typedef struct _MV_XML_FEATURE_Base_
{
    enum MV_XML_AccessMode enAccessMode;                           ///< \~chinese ģʽ         \~english Access Mode
}MV_XML_FEATURE_Base;

typedef struct _MV_XML_FEATURE_Integer_
{
    char                strName[MV_MAX_XML_NODE_STRLEN_C];
    char                strDisplayName[MV_MAX_XML_NODE_STRLEN_C];
    char                strDescription[MV_MAX_XML_DISC_STRLEN_C];   ///< \~chinese Ŀǰݲ֧     \~english NOT SUPPORT NOW
    char                strToolTip[MV_MAX_XML_DISC_STRLEN_C];

    enum MV_XML_Visibility  enVisivility;                           ///< \~chinese Ƿɼ         \~english Visible
    enum MV_XML_AccessMode  enAccessMode;                           ///< \~chinese ģʽ         \~english Access Mode
    int                 bIsLocked;                                  ///< \~chinese Ƿ0-1-,Ŀǰݲ֧    \~english Locked. 0-NO; 1-YES, NOT SUPPORT NOW
    int64_t             nValue;                                     ///< \~chinese ǰֵ           \~english Current Value
    int64_t             nMinValue;                                  ///< \~chinese Сֵ           \~english Min Value
    int64_t             nMaxValue;                                  ///< \~chinese ֵ           \~english Max Value
    int64_t             nIncrement;                                 ///< \~chinese              \~english Increment

    unsigned int        nReserved[4];

}MV_XML_FEATURE_Integer;

typedef struct _MV_XML_FEATURE_Boolean_
{
    char                strName[MV_MAX_XML_NODE_STRLEN_C];
    char                strDisplayName[MV_MAX_XML_NODE_STRLEN_C];
    char                strDescription[MV_MAX_XML_DISC_STRLEN_C];   ///< \~chinese Ŀǰݲ֧     \~english NOT SUPPORT NOW
    char                strToolTip[MV_MAX_XML_DISC_STRLEN_C];

    enum MV_XML_Visibility  enVisivility;                           ///< \~chinese Ƿɼ         \~english Visible
    enum MV_XML_AccessMode  enAccessMode;                           ///< \~chinese ģʽ         \~english Access Mode
    int                 bIsLocked;                                  ///< \~chinese Ƿ0-1-,Ŀǰݲ֧    \~english Locked. 0-NO; 1-YES, NOT SUPPORT NOW
    bool                bValue;                                     ///< \~chinese ǰֵ           \~english Current Value

    unsigned int        nReserved[4];
}MV_XML_FEATURE_Boolean;

typedef struct _MV_XML_FEATURE_Command_
{
    char                strName[MV_MAX_XML_NODE_STRLEN_C];
    char                strDisplayName[MV_MAX_XML_NODE_STRLEN_C];
    char                strDescription[MV_MAX_XML_DISC_STRLEN_C];   ///< \~chinese Ŀǰݲ֧     \~english NOT SUPPORT NOW
    char                strToolTip[MV_MAX_XML_DISC_STRLEN_C];

    enum MV_XML_Visibility  enVisivility;                           ///< \~chinese Ƿɼ         \~english Visible
    enum MV_XML_AccessMode  enAccessMode;                           ///< \~chinese ģʽ         \~english Access Mode
    int                 bIsLocked;                                  ///< \~chinese Ƿ0-1-,Ŀǰݲ֧    \~english Locked. 0-NO; 1-YES, NOT SUPPORT NOW

    unsigned int        nReserved[4];
}MV_XML_FEATURE_Command;

typedef struct _MV_XML_FEATURE_Float_
{
    char                strName[MV_MAX_XML_NODE_STRLEN_C];
    char                strDisplayName[MV_MAX_XML_NODE_STRLEN_C];
    char                strDescription[MV_MAX_XML_DISC_STRLEN_C];   ///< \~chinese Ŀǰݲ֧     \~english NOT SUPPORT NOW
    char                strToolTip[MV_MAX_XML_DISC_STRLEN_C];

    enum MV_XML_Visibility  enVisivility;                           ///< \~chinese Ƿɼ         \~english Visible
    enum MV_XML_AccessMode  enAccessMode;                           ///< \~chinese ģʽ         \~english Access Mode
    int                 bIsLocked;                                  ///< \~chinese Ƿ0-1-,Ŀǰݲ֧    \~english Locked. 0-NO; 1-YES, NOT SUPPORT NOW
    double              dfValue;                                    ///< \~chinese ǰֵ           \~english Current Value
    double              dfMinValue;                                 ///< \~chinese Сֵ           \~english Min Value
    double              dfMaxValue;                                 ///< \~chinese ֵ           \~english Max Value
    double              dfIncrement;                                ///< \~chinese              \~english Increment

    unsigned int        nReserved[4];
}MV_XML_FEATURE_Float;

typedef struct _MV_XML_FEATURE_String_
{
    char                strName[MV_MAX_XML_NODE_STRLEN_C];
    char                strDisplayName[MV_MAX_XML_NODE_STRLEN_C];
    char                strDescription[MV_MAX_XML_DISC_STRLEN_C];   ///< \~chinese Ŀǰݲ֧     \~english NOT SUPPORT NOW
    char                strToolTip[MV_MAX_XML_DISC_STRLEN_C];

    enum MV_XML_Visibility  enVisivility;                           ///< \~chinese Ƿɼ         \~english Visible
    enum MV_XML_AccessMode  enAccessMode;                           ///< \~chinese ģʽ         \~english Access Mode
    int                 bIsLocked;                                  ///< \~chinese Ƿ0-1-,Ŀǰݲ֧    \~english Locked. 0-NO; 1-YES, NOT SUPPORT NOW
    char                strValue[MV_MAX_XML_STRVALUE_STRLEN_C];     ///< \~chinese ǰֵ           \~english Current Value

    unsigned int        nReserved[4];
}MV_XML_FEATURE_String;

typedef struct _MV_XML_FEATURE_Register_
{
    char                strName[MV_MAX_XML_NODE_STRLEN_C];
    char                strDisplayName[MV_MAX_XML_NODE_STRLEN_C];
    char                strDescription[MV_MAX_XML_DISC_STRLEN_C];   ///< \~chinese Ŀǰݲ֧     \~english NOT SUPPORT NOW
    char                strToolTip[MV_MAX_XML_DISC_STRLEN_C];

    enum MV_XML_Visibility  enVisivility;                           ///< \~chinese Ƿɼ         \~english Visible
    enum MV_XML_AccessMode  enAccessMode;                           ///< \~chinese ģʽ         \~english Access Mode
    int                 bIsLocked;                                  ///< \~chinese Ƿ0-1-,Ŀǰݲ֧    \~english Locked. 0-NO; 1-YES, NOT SUPPORT NOW
    int64_t             nAddrValue;                                 ///< \~chinese ǰֵ           \~english Current Value

    unsigned int        nReserved[4];
}MV_XML_FEATURE_Register;

typedef struct _MV_XML_FEATURE_Category_
{
    char                strDescription[MV_MAX_XML_DISC_STRLEN_C];   ///< \~chinese ڵ Ŀǰݲ֧    \~english Node Description, NOT SUPPORT NOW
    char                strDisplayName[MV_MAX_XML_NODE_STRLEN_C];   ///< \~chinese ʾ         \~english Display Name
    char                strName[MV_MAX_XML_NODE_STRLEN_C];          ///< \~chinese ڵ           \~english Node Name
    char                strToolTip[MV_MAX_XML_DISC_STRLEN_C];       ///< \~chinese ʾ             \~english Notice

    enum MV_XML_Visibility  enVisivility;                           ///< \~chinese Ƿɼ         \~english Visible

    unsigned int        nReserved[4];
}MV_XML_FEATURE_Category;

typedef struct _MV_XML_FEATURE_EnumEntry_
{
    char                strName[MV_MAX_XML_NODE_STRLEN_C];
    char                strDisplayName[MV_MAX_XML_NODE_STRLEN_C];
    char                strDescription[MV_MAX_XML_DISC_STRLEN_C];   ///< \~chinese Ŀǰݲ֧     \~english NOT SUPPORT NOW
    char                strToolTip[MV_MAX_XML_DISC_STRLEN_C];
    int                 bIsImplemented;
    int                 nParentsNum;
    MV_XML_NODE_FEATURE stParentsList[MV_MAX_XML_PARENTS_NUM];

    enum MV_XML_Visibility  enVisivility;                           ///< \~chinese Ƿɼ         \~english Visible
    int64_t             nValue;                                     ///< \~chinese ǰֵ           \~english Current Value
    enum MV_XML_AccessMode  enAccessMode;                           ///< \~chinese ģʽ         \~english Access Mode
    int                 bIsLocked;                                  ///< \~chinese Ƿ0-1-,Ŀǰݲ֧    \~english Locked. 0-NO; 1-YES, NOT SUPPORT NOW
    int                 nReserved[8];

}MV_XML_FEATURE_EnumEntry;

typedef struct _MV_XML_FEATURE_Enumeration_
{
    enum MV_XML_Visibility  enVisivility;                           ///< \~chinese Ƿɼ         \~english Visible
    char                strDescription[MV_MAX_XML_DISC_STRLEN_C];   ///< \~chinese ڵ Ŀǰݲ֧    \~english Node Description, NOT SUPPORT NOW
    char                strDisplayName[MV_MAX_XML_NODE_STRLEN_C];   ///< \~chinese ʾ         \~english Display Name
    char                strName[MV_MAX_XML_NODE_STRLEN_C];          ///< \~chinese ڵ           \~english Node Name
    char                strToolTip[MV_MAX_XML_DISC_STRLEN_C];       ///< \~chinese ʾ             \~english Notice

    int                 nSymbolicNum;                               ///< \~chinese ymbolic        \~english Symbolic Number
    char                strCurrentSymbolic[MV_MAX_XML_SYMBOLIC_STRLEN_C];///< \~chinese ǰSymbolic    \~english Current Symbolic Index
    char                strSymbolic[MV_MAX_XML_SYMBOLIC_NUM][MV_MAX_XML_SYMBOLIC_STRLEN_C];
    enum MV_XML_AccessMode   enAccessMode;                          ////< \~chinese ģʽ        \~english Access Mode
    int                 bIsLocked;                                  ///< \~chinese Ƿ0-1-,Ŀǰݲ֧    \~english Locked. 0-NO; 1-YES, NOT SUPPORT NOW
    int64_t             nValue;                                     ///< \~chinese ǰֵ           \~english Current Value

    unsigned int        nReserved[4];
}MV_XML_FEATURE_Enumeration;

typedef struct _MV_XML_FEATURE_Port_
{
    enum MV_XML_Visibility  enVisivility;                           ///< \~chinese Ƿɼ         \~english Visible
    char                strDescription[MV_MAX_XML_DISC_STRLEN_C];   ///< \~chinese ڵ,Ŀǰݲ֧    \~english Node Description, NOT SUPPORT NOW
    char                strDisplayName[MV_MAX_XML_NODE_STRLEN_C];   ///< \~chinese ʾ         \~english Display Name
    char                strName[MV_MAX_XML_NODE_STRLEN_C];          ///< \~chinese ڵ           \~english Node Name
    char                strToolTip[MV_MAX_XML_DISC_STRLEN_C];       ///< \~chinese ʾ             \~english Notice

    enum MV_XML_AccessMode  enAccessMode;                           ///< \~chinese ģʽ         \~english Access Mode
    int                 bIsLocked;                                  ///< \~chinese Ƿ0-1-,Ŀǰݲ֧    \~english Locked. 0-NO; 1-YES, NOT SUPPORT NOW

    unsigned int        nReserved[4];
}MV_XML_FEATURE_Port;

typedef struct _MV_XML_CAMERA_FEATURE_
{
    enum MV_XML_InterfaceType    enType;
    union
    {
        MV_XML_FEATURE_Integer      stIntegerFeature;
        MV_XML_FEATURE_Float        stFloatFeature;
        MV_XML_FEATURE_Enumeration  stEnumerationFeature;
        MV_XML_FEATURE_String       stStringFeature;
    }SpecialFeature;

}MV_XML_CAMERA_FEATURE;



/// \~chinese ͼƬ              \~english Save Image Parameters
typedef struct _MV_SAVE_IMAGE_PARAM_T_EX_
{
    unsigned char*          pData;                                  ///< [IN]  \~chinese ݻ           \~english Input Data Buffer
    unsigned int            nDataLen;                               ///< [IN]  \~chinese ݳ           \~english Input Data length
    enum MvGvspPixelType    enPixelType;                            ///< [IN]  \~chinese ݵظʽ     \~english Input Data Pixel Format
    unsigned short          nWidth;                                 ///< [IN]  \~chinese ͼ                 \~english Image Width
    unsigned short          nHeight;                                ///< [IN]  \~chinese ͼ                 \~english Image Height

    unsigned char*          pImageBuffer;                           ///< [OUT] \~chinese ͼƬ           \~english Output Image Buffer
    unsigned int            nImageLen;                              ///< [OUT] \~chinese ͼƬ           \~english Output Image length
    unsigned int            nBufferSize;                            ///< [IN]  \~chinese ṩС   \~english Output buffer size provided
    enum MV_SAVE_IAMGE_TYPE enImageType;                            ///< [IN]  \~chinese ͼƬʽ           \~english Output Image Format
    unsigned int            nJpgQuality;                            ///< [IN]  \~chinese JPG(50-99]ʽЧ   \~english Encoding quality(50-99]Other formats are invalid


    unsigned int            iMethodValue;                           ///< [IN]  \~chinese ֵ 0- 1- 2-ţֵĬΪţ  \~english Bayer interpolation method  0-Fast 1-Equilibrium 2-Optimal

    unsigned int            nReserved[3];                           ///<       \~chinese Ԥ                   \~english Reserved

}MV_SAVE_IMAGE_PARAM_EX;



/// \~chinese ͼƬ              \~english Save Image Parameters
typedef struct _MV_SAVE_IMG_TO_FILE_PARAM_
{
    enum MvGvspPixelType    enPixelType;                            ///< [IN]  \~chineseݵظʽ      \~english The pixel format of the input data
    unsigned char*          pData;                                  ///< [IN]  \~chinese ݻ           \~english Input Data Buffer
    unsigned int            nDataLen;                               ///< [IN]  \~chinese ݳ           \~english Input Data length
    unsigned short          nWidth;                                 ///< [IN]  \~chinese ͼ                 \~english Image Width
    unsigned short          nHeight;                                ///< [IN]  \~chinese ͼ                 \~english Image Height
    enum MV_SAVE_IAMGE_TYPE enImageType;                            ///< [IN]  \~chinese ͼƬʽ           \~english Input Image Format
    unsigned int            nQuality;                               ///< [IN]  \~chinese JPG(50-99]PNG[0-9]ʽЧ \~english JPG Encoding quality(50-99],PNG Encoding quality[0-9]Other formats are invalid
    char                    pImagePath[256];                        ///< [IN]  \~chinese ļ·           \~english Input file path

    int                     iMethodValue;                           ///< [IN]  \~chinese ֵ 0- 1- 2-ţֵĬΪţ  \~english Bayer interpolation method  0-Fast 1-Equilibrium 2-Optimal

    unsigned int            nReserved[8];                           ///<       \~chinese Ԥ                   \~english Reserved

}MV_SAVE_IMG_TO_FILE_PARAM;


// \~chinese תṹ            \~english Pixel convert structure
typedef struct _MV_CC_PIXEL_CONVERT_PARAM_
{
    unsigned short          nWidth;                                 ///< [IN]  \~chinese ͼ                 \~english Width
    unsigned short          nHeight;                                ///< [IN]  \~chinese ͼ                 \~english Height

    enum MvGvspPixelType    enSrcPixelType;                         ///< [IN]  \~chinese Դظʽ             \~english Source pixel format
    unsigned char*          pSrcData;                               ///< [IN]  \~chinese ݻ           \~english Input data buffer
    unsigned int            nSrcDataLen;                            ///< [IN]  \~chinese ݳ           \~english Input data length

    enum MvGvspPixelType    enDstPixelType;                         ///< [IN]  \~chinese Ŀظʽ           \~english Destination pixel format
    unsigned char*          pDstBuffer;                             ///< [OUT] \~chinese ݻ           \~english Output data buffer
    unsigned int            nDstLen;                                ///< [OUT] \~chinese ݳ           \~english Output data length
    unsigned int            nDstBufferSize;                         ///< [IN]  \~chinese ṩС   \~english Provided output buffer size

    unsigned int            nRes[4];                                ///<       \~chinese Ԥ                   \~english Reserved

}MV_CC_PIXEL_CONVERT_PARAM;




#endif /* _MV_OBSOLETE_CAM_PARAMS_H_ */
